Bug 1529981 - gcc: incorrect CFI information on i386 with -fstack-clash-protection
Summary: gcc: incorrect CFI information on i386 with -fstack-clash-protection
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: gcc
Version: 7.5
Hardware: i386
OS: Unspecified
unspecified
unspecified
Target Milestone: rc
: ---
Assignee: Marek Polacek
QA Contact: Michael Petlan
URL:
Whiteboard:
Depends On: 1529979
Blocks: 1529982
TreeView+ depends on / blocked
 
Reported: 2017-12-31 16:22 UTC by Florian Weimer
Modified: 2018-04-10 15:14 UTC (History)
4 users (show)

Fixed In Version: gcc-4.8.5-26.el7
Doc Type: No Doc Update
Doc Text:
undefined
Clone Of: 1529979
Environment:
Last Closed: 2018-04-10 15:12:44 UTC
Target Upstream Version:


Attachments (Terms of Use)
unwind.i cleaned up for GCC 4.8 (229.50 KB, text/plain)
2017-12-31 16:22 UTC, Florian Weimer
no flags Details


Links
System ID Priority Status Summary Last Updated
GNU Compiler Collection 83641 None None None 2017-12-31 17:17:43 UTC
Red Hat Product Errata RHSA-2018:0849 None None None 2018-04-10 15:14:06 UTC

Description Florian Weimer 2017-12-31 16:22:30 UTC
Created attachment 1374985 [details]
unwind.i cleaned up for GCC 4.8

This also seems to affect gcc-4.8.5-25.el7.x86_64.  Based on the disassembly of /lib/libpthread.so.0, glibc-2.17-220.el7.i686 is miscompiled as well.

+++ This bug was initially created as a clone of Bug #1529979 +++

Description of problem:

The attached program, when compiled using

gcc -fPIC -O2 -fgnu89-inline-fstack-clash-protection -c unwind.i

produces invalid CFI instructions for __GI___pthread_unwind:

__GI___pthread_unwind:
.LFB55:
        .cfi_startproc
        pushl   %esi
        .cfi_def_cfa_offset 8
        .cfi_offset 6, -8
        pushl   %ebx
        .cfi_def_cfa_offset 12
        .cfi_offset 3, -12
        pushl   %esi
        .cfi_def_cfa_offset 16
        .cfi_offset 6, -16
        popl    %esi
        .cfi_restore 6
        .cfi_def_cfa_offset 12
        call    __x86.get_pc_thunk.bx
        addl    $_GLOBAL_OFFSET_TABLE_, %ebx
        subl    $8, %esp
        .cfi_def_cfa_offset 20
        movl    %eax, %esi

The problem is that the .cfi_restore for %esi does not restore the original location at offset 8, but essentially declares that the register will not be clobbered further below, while in fact it is used to store the function argument (__pthread_unwind is compiled with __attribute__ ((regparm (1)))).

As a result, the libgcc unwinder restores the wrong value for %esi, leading to bug 1529549.

Version-Release number of selected component (if applicable):

gcc-7.2.1-4.fc28.i686

Comment 3 Michael Petlan 2018-02-19 15:48:50 UTC
Related tests passed with gcc-4.8.5-28.el7.
VERIFIED.

Comment 6 errata-xmlrpc 2018-04-10 15:12:44 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHSA-2018:0849


Note You need to log in before you can comment on or make changes to this bug.